using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.Win32;

namespace RegistryBrowser {
	public partial class frmRegistryBrowser : Form {
		public frmRegistryBrowser() {
			InitializeComponent();

			// Set up a root node.
			TreeNode RootNode = new TreeNode("Current User");
			RootNode.Tag = Registry.CurrentUser;
			this.tvSections.Nodes.Add(RootNode);

			// Add a dud.
			if (Registry.LocalMachine.SubKeyCount > 0) RootNode.Nodes.Add("");
			

		}

		private void tvSections_BeforeExpand(object sender, TreeViewCancelEventArgs e) {

			// We're expanding...
			RegistryKey ExpandingKey = e.Node.Tag as RegistryKey;

			if (ExpandingKey != null) {

				// Purge the dud:
				e.Node.Nodes.Clear();


				// Iterate over subkeys:
				foreach (string SubKey in ExpandingKey.GetSubKeyNames()) {
					// Create a new sub-node:
					TreeNode SubKeyNode = new TreeNode(SubKey);

					// Open the registry sub-key:
					try {
						RegistryKey SubKeyNodeTag = ExpandingKey.OpenSubKey(SubKey);
						SubKeyNode.Tag = SubKeyNodeTag;

						// Add dud if there are more keys underneath.
						if (SubKeyNodeTag.SubKeyCount > 0) SubKeyNode.Nodes.Add("");

						// Add!
						e.Node.Nodes.Add(SubKeyNode);
					} catch { } 
					
				}
			}
		}

	}
}